# This program uses a function to aid with the sorting.
# To run this program students will be required to run the function within the shell.

# EXAMPLE:              sort([23,56,12,23,45,67,898])

# This will run the program and display the results from sorting the numbers using the quick sort method. 


def sort(array):

    

    # Blank arrays used within sort.  When an element is found to be less than the pivot it is placed into the less array.
    # When an element is found to be greater than the pivot it is placed into the greater array.
    # This process is repeated untill list is fully sorted.
    
    less = []
    equal = []
    greater = []


    # Will only conduct the sorting if the array requires it. 

    if len(array) > 1:

        # pivot is chosen using element 0.  Other quick sort methods may choose a different pivot so please note this. 
        
        pivot = array[0]

        # For testing and understanding purposes the pivot is outputted onto the screen for students to see. 

        print("The number used for pivot is:", array[0])

        # cycles through the array.  Moves the numbers into their correct arrays based on if they are smaller, equal or greater than the pivot.
        # Each time a number is moved all the lists are shown to the user to aid in demonstrating how the sort works.

        for x in array:
            if x < pivot:
                less.append(x)
                print(less,equal,greater)
            if x == pivot:
                equal.append(x)
                print(less,equal,greater)
            if x > pivot:
                greater.append(x)
                print(less,equal,greater)
                
        print("-"*30)


         # Outputs the sorted list. 
        return sort(less)+equal+sort(greater)        
    
    else: 
        return array
